git-stash.shon commit Merge branch 'jl/submodule-update-retire-orig-flags' (c83386d)
   1#!/bin/sh
   2# Copyright (c) 2007, Nanako Shiraishi
   3
   4dashless=$(basename "$0" | sed -e 's/-/ /')
   5USAGE="list [<options>]
   6   or: $dashless show [<stash>]
   7   or: $dashless drop [-q|--quiet] [<stash>]
   8   or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
   9   or: $dashless branch <branchname> [<stash>]
  10   or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
  11                       [-u|--include-untracked] [-a|--all] [<message>]]
  12   or: $dashless clear"
  13
  14SUBDIRECTORY_OK=Yes
  15OPTIONS_SPEC=
  16START_DIR=`pwd`
  17. git-sh-setup
  18. git-sh-i18n
  19require_work_tree
  20cd_to_toplevel
  21
  22TMP="$GIT_DIR/.git-stash.$$"
  23TMPindex=${GIT_INDEX_FILE-"$GIT_DIR/index"}.stash.$$
  24trap 'rm -f "$TMP-"* "$TMPindex"' 0
  25
  26ref_stash=refs/stash
  27
  28if git config --get-colorbool color.interactive; then
  29       help_color="$(git config --get-color color.interactive.help 'red bold')"
  30       reset_color="$(git config --get-color '' reset)"
  31else
  32       help_color=
  33       reset_color=
  34fi
  35
  36no_changes () {
  37        git diff-index --quiet --cached HEAD --ignore-submodules -- &&
  38        git diff-files --quiet --ignore-submodules &&
  39        (test -z "$untracked" || test -z "$(untracked_files)")
  40}
  41
  42untracked_files () {
  43        excl_opt=--exclude-standard
  44        test "$untracked" = "all" && excl_opt=
  45        git ls-files -o -z $excl_opt
  46}
  47
  48clear_stash () {
  49        if test $# != 0
  50        then
  51                die "$(gettext "git stash clear with parameters is unimplemented")"
  52        fi
  53        if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
  54        then
  55                git update-ref -d $ref_stash $current
  56        fi
  57}
  58
  59create_stash () {
  60        stash_msg="$1"
  61        untracked="$2"
  62
  63        git update-index -q --refresh
  64        if no_changes
  65        then
  66                exit 0
  67        fi
  68
  69        # state of the base commit
  70        if b_commit=$(git rev-parse --verify HEAD)
  71        then
  72                head=$(git rev-list --oneline -n 1 HEAD --)
  73        else
  74                die "$(gettext "You do not have the initial commit yet")"
  75        fi
  76
  77        if branch=$(git symbolic-ref -q HEAD)
  78        then
  79                branch=${branch#refs/heads/}
  80        else
  81                branch='(no branch)'
  82        fi
  83        msg=$(printf '%s: %s' "$branch" "$head")
  84
  85        # state of the index
  86        i_tree=$(git write-tree) &&
  87        i_commit=$(printf 'index on %s\n' "$msg" |
  88                git commit-tree $i_tree -p $b_commit) ||
  89                die "$(gettext "Cannot save the current index state")"
  90
  91        if test -n "$untracked"
  92        then
  93                # Untracked files are stored by themselves in a parentless commit, for
  94                # ease of unpacking later.
  95                u_commit=$(
  96                        untracked_files | (
  97                                export GIT_INDEX_FILE="$TMPindex"
  98                                rm -f "$TMPindex" &&
  99                                git update-index -z --add --remove --stdin &&
 100                                u_tree=$(git write-tree) &&
 101                                printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree  &&
 102                                rm -f "$TMPindex"
 103                ) ) || die "Cannot save the untracked files"
 104
 105                untracked_commit_option="-p $u_commit";
 106        else
 107                untracked_commit_option=
 108        fi
 109
 110        if test -z "$patch_mode"
 111        then
 112
 113                # state of the working tree
 114                w_tree=$( (
 115                        git read-tree --index-output="$TMPindex" -m $i_tree &&
 116                        GIT_INDEX_FILE="$TMPindex" &&
 117                        export GIT_INDEX_FILE &&
 118                        git diff --name-only -z HEAD -- >"$TMP-stagenames" &&
 119                        git update-index -z --add --remove --stdin <"$TMP-stagenames" &&
 120                        git write-tree &&
 121                        rm -f "$TMPindex"
 122                ) ) ||
 123                        die "$(gettext "Cannot save the current worktree state")"
 124
 125        else
 126
 127                rm -f "$TMP-index" &&
 128                GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
 129
 130                # find out what the user wants
 131                GIT_INDEX_FILE="$TMP-index" \
 132                        git add--interactive --patch=stash -- &&
 133
 134                # state of the working tree
 135                w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
 136                die "$(gettext "Cannot save the current worktree state")"
 137
 138                git diff-tree -p HEAD $w_tree -- >"$TMP-patch" &&
 139                test -s "$TMP-patch" ||
 140                die "$(gettext "No changes selected")"
 141
 142                rm -f "$TMP-index" ||
 143                die "$(gettext "Cannot remove temporary index (can't happen)")"
 144
 145        fi
 146
 147        # create the stash
 148        if test -z "$stash_msg"
 149        then
 150                stash_msg=$(printf 'WIP on %s' "$msg")
 151        else
 152                stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
 153        fi
 154        w_commit=$(printf '%s\n' "$stash_msg" |
 155        git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
 156        die "$(gettext "Cannot record working tree state")"
 157}
 158
 159store_stash () {
 160        while test $# != 0
 161        do
 162                case "$1" in
 163                -m|--message)
 164                        shift
 165                        stash_msg="$1"
 166                        ;;
 167                -q|--quiet)
 168                        quiet=t
 169                        ;;
 170                *)
 171                        break
 172                        ;;
 173                esac
 174                shift
 175        done
 176        test $# = 1 ||
 177        die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
 178
 179        w_commit="$1"
 180        if test -z "$stash_msg"
 181        then
 182                stash_msg="Created via \"git stash store\"."
 183        fi
 184
 185        # Make sure the reflog for stash is kept.
 186        : >>"$GIT_DIR/logs/$ref_stash"
 187        git update-ref -m "$stash_msg" $ref_stash $w_commit
 188        ret=$?
 189        test $ret != 0 && test -z $quiet &&
 190        die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
 191        return $ret
 192}
 193
 194save_stash () {
 195        keep_index=
 196        patch_mode=
 197        untracked=
 198        while test $# != 0
 199        do
 200                case "$1" in
 201                -k|--keep-index)
 202                        keep_index=t
 203                        ;;
 204                --no-keep-index)
 205                        keep_index=n
 206                        ;;
 207                -p|--patch)
 208                        patch_mode=t
 209                        # only default to keep if we don't already have an override
 210                        test -z "$keep_index" && keep_index=t
 211                        ;;
 212                -q|--quiet)
 213                        GIT_QUIET=t
 214                        ;;
 215                -u|--include-untracked)
 216                        untracked=untracked
 217                        ;;
 218                -a|--all)
 219                        untracked=all
 220                        ;;
 221                --)
 222                        shift
 223                        break
 224                        ;;
 225                -*)
 226                        option="$1"
 227                        # TRANSLATORS: $option is an invalid option, like
 228                        # `--blah-blah'. The 7 spaces at the beginning of the
 229                        # second line correspond to "error: ". So you should line
 230                        # up the second line with however many characters the
 231                        # translation of "error: " takes in your language. E.g. in
 232                        # English this is:
 233                        #
 234                        #    $ git stash save --blah-blah 2>&1 | head -n 2
 235                        #    error: unknown option for 'stash save': --blah-blah
 236                        #           To provide a message, use git stash save -- '--blah-blah'
 237                        eval_gettextln "error: unknown option for 'stash save': \$option
 238       To provide a message, use git stash save -- '\$option'"
 239                        usage
 240                        ;;
 241                *)
 242                        break
 243                        ;;
 244                esac
 245                shift
 246        done
 247
 248        if test -n "$patch_mode" && test -n "$untracked"
 249        then
 250            die "Can't use --patch and --include-untracked or --all at the same time"
 251        fi
 252
 253        stash_msg="$*"
 254
 255        git update-index -q --refresh
 256        if no_changes
 257        then
 258                say "$(gettext "No local changes to save")"
 259                exit 0
 260        fi
 261        test -f "$GIT_DIR/logs/$ref_stash" ||
 262                clear_stash || die "$(gettext "Cannot initialize stash")"
 263
 264        create_stash "$stash_msg" $untracked
 265        store_stash -m "$stash_msg" -q $w_commit ||
 266        die "$(gettext "Cannot save the current status")"
 267        say Saved working directory and index state "$stash_msg"
 268
 269        if test -z "$patch_mode"
 270        then
 271                git reset --hard ${GIT_QUIET:+-q}
 272                test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
 273                if test -n "$untracked"
 274                then
 275                        git clean --force --quiet -d $CLEAN_X_OPTION
 276                fi
 277
 278                if test "$keep_index" = "t" && test -n $i_tree
 279                then
 280                        git read-tree --reset -u $i_tree
 281                fi
 282        else
 283                git apply -R < "$TMP-patch" ||
 284                die "$(gettext "Cannot remove worktree changes")"
 285
 286                if test "$keep_index" != "t"
 287                then
 288                        git reset
 289                fi
 290        fi
 291}
 292
 293have_stash () {
 294        git rev-parse --verify $ref_stash >/dev/null 2>&1
 295}
 296
 297list_stash () {
 298        have_stash || return 0
 299        git log --format="%gd: %gs" -g "$@" $ref_stash --
 300}
 301
 302show_stash () {
 303        assert_stash_like "$@"
 304
 305        git diff ${FLAGS:---stat} $b_commit $w_commit
 306}
 307
 308#
 309# Parses the remaining options looking for flags and
 310# at most one revision defaulting to ${ref_stash}@{0}
 311# if none found.
 312#
 313# Derives related tree and commit objects from the
 314# revision, if one is found.
 315#
 316# stash records the work tree, and is a merge between the
 317# base commit (first parent) and the index tree (second parent).
 318#
 319#   REV is set to the symbolic version of the specified stash-like commit
 320#   IS_STASH_LIKE is non-blank if ${REV} looks like a stash
 321#   IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
 322#   s is set to the SHA1 of the stash commit
 323#   w_commit is set to the commit containing the working tree
 324#   b_commit is set to the base commit
 325#   i_commit is set to the commit containing the index tree
 326#   u_commit is set to the commit containing the untracked files tree
 327#   w_tree is set to the working tree
 328#   b_tree is set to the base tree
 329#   i_tree is set to the index tree
 330#   u_tree is set to the untracked files tree
 331#
 332#   GIT_QUIET is set to t if -q is specified
 333#   INDEX_OPTION is set to --index if --index is specified.
 334#   FLAGS is set to the remaining flags
 335#
 336# dies if:
 337#   * too many revisions specified
 338#   * no revision is specified and there is no stash stack
 339#   * a revision is specified which cannot be resolve to a SHA1
 340#   * a non-existent stash reference is specified
 341#
 342
 343parse_flags_and_rev()
 344{
 345        test "$PARSE_CACHE" = "$*" && return 0 # optimisation
 346        PARSE_CACHE="$*"
 347
 348        IS_STASH_LIKE=
 349        IS_STASH_REF=
 350        INDEX_OPTION=
 351        s=
 352        w_commit=
 353        b_commit=
 354        i_commit=
 355        u_commit=
 356        w_tree=
 357        b_tree=
 358        i_tree=
 359        u_tree=
 360
 361        REV=$(git rev-parse --no-flags --symbolic "$@") || exit 1
 362
 363        FLAGS=
 364        for opt
 365        do
 366                case "$opt" in
 367                        -q|--quiet)
 368                                GIT_QUIET=-t
 369                        ;;
 370                        --index)
 371                                INDEX_OPTION=--index
 372                        ;;
 373                        -*)
 374                                FLAGS="${FLAGS}${FLAGS:+ }$opt"
 375                        ;;
 376                esac
 377        done
 378
 379        set -- $REV
 380
 381        case $# in
 382                0)
 383                        have_stash || die "$(gettext "No stash found.")"
 384                        set -- ${ref_stash}@{0}
 385                ;;
 386                1)
 387                        :
 388                ;;
 389                *)
 390                        die "$(eval_gettext "Too many revisions specified: \$REV")"
 391                ;;
 392        esac
 393
 394        REV=$(git rev-parse --quiet --symbolic --verify $1 2>/dev/null) || {
 395                reference="$1"
 396                die "$(eval_gettext "\$reference is not valid reference")"
 397        }
 398
 399        i_commit=$(git rev-parse --quiet --verify $REV^2 2>/dev/null) &&
 400        set -- $(git rev-parse $REV $REV^1 $REV: $REV^1: $REV^2: 2>/dev/null) &&
 401        s=$1 &&
 402        w_commit=$1 &&
 403        b_commit=$2 &&
 404        w_tree=$3 &&
 405        b_tree=$4 &&
 406        i_tree=$5 &&
 407        IS_STASH_LIKE=t &&
 408        test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
 409        IS_STASH_REF=t
 410
 411        u_commit=$(git rev-parse --quiet --verify $REV^3 2>/dev/null) &&
 412        u_tree=$(git rev-parse $REV^3: 2>/dev/null)
 413}
 414
 415is_stash_like()
 416{
 417        parse_flags_and_rev "$@"
 418        test -n "$IS_STASH_LIKE"
 419}
 420
 421assert_stash_like() {
 422        is_stash_like "$@" || {
 423                args="$*"
 424                die "$(eval_gettext "'\$args' is not a stash-like commit")"
 425        }
 426}
 427
 428is_stash_ref() {
 429        is_stash_like "$@" && test -n "$IS_STASH_REF"
 430}
 431
 432assert_stash_ref() {
 433        is_stash_ref "$@" || {
 434                args="$*"
 435                die "$(eval_gettext "'\$args' is not a stash reference")"
 436        }
 437}
 438
 439apply_stash () {
 440
 441        assert_stash_like "$@"
 442
 443        git update-index -q --refresh || die "$(gettext "unable to refresh index")"
 444
 445        # current index state
 446        c_tree=$(git write-tree) ||
 447                die "$(gettext "Cannot apply a stash in the middle of a merge")"
 448
 449        unstashed_index_tree=
 450        if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
 451                        test "$c_tree" != "$i_tree"
 452        then
 453                git diff-tree --binary $s^2^..$s^2 | git apply --cached
 454                test $? -ne 0 &&
 455                        die "$(gettext "Conflicts in index. Try without --index.")"
 456                unstashed_index_tree=$(git write-tree) ||
 457                        die "$(gettext "Could not save index tree")"
 458                git reset
 459        fi
 460
 461        if test -n "$u_tree"
 462        then
 463                GIT_INDEX_FILE="$TMPindex" git-read-tree "$u_tree" &&
 464                GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
 465                rm -f "$TMPindex" ||
 466                die 'Could not restore untracked files from stash'
 467        fi
 468
 469        eval "
 470                GITHEAD_$w_tree='Stashed changes' &&
 471                GITHEAD_$c_tree='Updated upstream' &&
 472                GITHEAD_$b_tree='Version stash was based on' &&
 473                export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
 474        "
 475
 476        if test -n "$GIT_QUIET"
 477        then
 478                GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
 479        fi
 480        if git merge-recursive $b_tree -- $c_tree $w_tree
 481        then
 482                # No conflict
 483                if test -n "$unstashed_index_tree"
 484                then
 485                        git read-tree "$unstashed_index_tree"
 486                else
 487                        a="$TMP-added" &&
 488                        git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
 489                        git read-tree --reset $c_tree &&
 490                        git update-index --add --stdin <"$a" ||
 491                                die "$(gettext "Cannot unstage modified files")"
 492                        rm -f "$a"
 493                fi
 494                squelch=
 495                if test -n "$GIT_QUIET"
 496                then
 497                        squelch='>/dev/null 2>&1'
 498                fi
 499                (cd "$START_DIR" && eval "git status $squelch") || :
 500        else
 501                # Merge conflict; keep the exit status from merge-recursive
 502                status=$?
 503                git rerere
 504                if test -n "$INDEX_OPTION"
 505                then
 506                        gettextln "Index was not unstashed." >&2
 507                fi
 508                exit $status
 509        fi
 510}
 511
 512pop_stash() {
 513        assert_stash_ref "$@"
 514
 515        apply_stash "$@" &&
 516        drop_stash "$@"
 517}
 518
 519drop_stash () {
 520        assert_stash_ref "$@"
 521
 522        git reflog delete --updateref --rewrite "${REV}" &&
 523                say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
 524                die "$(eval_gettext "\${REV}: Could not drop stash entry")"
 525
 526        # clear_stash if we just dropped the last stash entry
 527        git rev-parse --verify "$ref_stash@{0}" >/dev/null 2>&1 || clear_stash
 528}
 529
 530apply_to_branch () {
 531        test -n "$1" || die "$(gettext "No branch name specified")"
 532        branch=$1
 533        shift 1
 534
 535        set -- --index "$@"
 536        assert_stash_like "$@"
 537
 538        git checkout -b $branch $REV^ &&
 539        apply_stash "$@" && {
 540                test -z "$IS_STASH_REF" || drop_stash "$@"
 541        }
 542}
 543
 544PARSE_CACHE='--not-parsed'
 545# The default command is "save" if nothing but options are given
 546seen_non_option=
 547for opt
 548do
 549        case "$opt" in
 550        -*) ;;
 551        *) seen_non_option=t; break ;;
 552        esac
 553done
 554
 555test -n "$seen_non_option" || set "save" "$@"
 556
 557# Main command set
 558case "$1" in
 559list)
 560        shift
 561        list_stash "$@"
 562        ;;
 563show)
 564        shift
 565        show_stash "$@"
 566        ;;
 567save)
 568        shift
 569        save_stash "$@"
 570        ;;
 571apply)
 572        shift
 573        apply_stash "$@"
 574        ;;
 575clear)
 576        shift
 577        clear_stash "$@"
 578        ;;
 579create)
 580        shift
 581        create_stash "$*" && echo "$w_commit"
 582        ;;
 583store)
 584        shift
 585        store_stash "$@"
 586        ;;
 587drop)
 588        shift
 589        drop_stash "$@"
 590        ;;
 591pop)
 592        shift
 593        pop_stash "$@"
 594        ;;
 595branch)
 596        shift
 597        apply_to_branch "$@"
 598        ;;
 599*)
 600        case $# in
 601        0)
 602                save_stash &&
 603                say "$(gettext "(To restore them type \"git stash apply\")")"
 604                ;;
 605        *)
 606                usage
 607        esac
 608        ;;
 609esac